
#ifndef CLIENT_H
#define CLIENT_H

extern ClientNode *nodes;
extern ClientNode *nodeTail;

ClientNode *FindClientByWindow(Window w);
ClientNode *FindClientByParent(Window p);

void AddClientWindow(Window w, int alreadyMapped);
void RemoveClient(ClientNode *np);
void LoadClients();
void ReleaseClients();

void MinimizeClient(ClientNode *np);
void RestoreClient(ClientNode *np);
void MaximizeClient(ClientNode *np);
void FocusClient(ClientNode *np);
void RefocusClient();
void MoveClient(ClientNode *np);
void ResizeClient(ClientNode *np, BorderActionType action);
void DeleteClient(ClientNode *np);
void RaiseClient(ClientNode *np);
void RestackClients();
void SetClientLayer(ClientNode *np, int layer);
void SetClientDesktop(ClientNode *np, int desktop);
void SetClientSticky(ClientNode *np, int isSticky);

void HideClient(ClientNode *np);
void ShowClient(ClientNode *np);

void ReadClientHints(ClientNode *np);
void ReadMotifHints(ClientNode *np);

void SetShape(ClientNode *np);

void SendConfigureEvent(ClientNode *np);

#endif

