/*************************************************************************
 *************************************************************************/

#include "jwm.h"

#define STATUS_WINDOW_WIDTH 128

static Window statusWindow;
static GC statusGC;
static unsigned int statusWindowHeight;

/*************************************************************************
 *************************************************************************/
void CreateMoveWindow() {

	int x, y;

	statusWindowHeight = borderFont->ascent + borderFont->descent + 4;

	x = rootWidth / 2 - STATUS_WINDOW_WIDTH / 2;
	y = rootHeight / 2 - statusWindowHeight / 2;

	statusWindow = XCreateSimpleWindow(display, rootWindow, x, y,
		STATUS_WINDOW_WIDTH, statusWindowHeight, 1,
		colors[COLOR_BORDER_OUTLINE],
		colors[COLOR_BORDER]);
	XMapRaised(display, statusWindow);
	statusGC = XCreateGC(display, statusWindow, 0, NULL);
	XSetFont(display, statusGC, borderFont->fid);
	XSetBackground(display, statusGC, colors[COLOR_BORDER]);

}

/*************************************************************************
 *************************************************************************/
void UpdateMoveWindow(int x, int y) {
	char str[80];
	unsigned int width;

	XSetForeground(display, statusGC, colors[COLOR_BORDER]);
	XFillRectangle(display, statusWindow, statusGC, 0, 0,
		STATUS_WINDOW_WIDTH, statusWindowHeight);
	XSetForeground(display, statusGC, colors[COLOR_BORDER_TEXT]);

	sprintf(str, "(%d, %d)", x, y);
	width = XTextWidth(borderFont, str, strlen(str));
	XDrawString(display, statusWindow, statusGC,
		STATUS_WINDOW_WIDTH / 2 - width / 2,
		borderFont->ascent + 2,
		str, strlen(str));

	XFlush(display);
}

/*************************************************************************
 *************************************************************************/
void DestroyMoveWindow() {
	XFreeGC(display, statusGC);
	XDestroyWindow(display, statusWindow);
}

/*************************************************************************
 *************************************************************************/
void CreateResizeWindow() {
	CreateMoveWindow();
}

/*************************************************************************
 *************************************************************************/
void UpdateResizeWindow(int width, int height) {
	char str[80];
	unsigned int fontWidth;

	XSetForeground(display, statusGC, colors[COLOR_BORDER]);
	XFillRectangle(display, statusWindow, statusGC, 0, 0,
		STATUS_WINDOW_WIDTH, statusWindowHeight);
	XSetForeground(display, statusGC, colors[COLOR_BORDER_TEXT]);

	sprintf(str, "%d x %d", width, height);
	fontWidth = XTextWidth(borderFont, str, strlen(str));
	XDrawString(display, statusWindow, statusGC,
		STATUS_WINDOW_WIDTH / 2 - fontWidth / 2,
		borderFont->ascent + 2,
		str, strlen(str));

	XFlush(display);
}

/*************************************************************************
 *************************************************************************/
void DestroyResizeWindow() {
	DestroyMoveWindow();
}

